library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity CHATTERING is
  port ( CLK   : in   std_logic;
  			CE    : in   std_logic;
  		   RST   : in   std_logic;
         A_IN  : in   std_logic;
         B_IN  : in   std_logic;
         A_OUT : out  std_logic;
         B_OUT : out  std_logic );
end CHATTERING;

architecture RTL of CHATTERING is

begin

process( CLK, RST ) begin
	if( RST = '1') then
		A_OUT <= '0';
		B_OUT <= '0';
	elsif( CLK'event and CLK = '1') then
		if( CE='1') then
			A_OUT <= not A_IN;
			B_OUT <= not B_IN;
		end if;
	end if;
end process;

end RTL;
