library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity SEG_DECODER is
	port ( D_IN  : in  std_logic_vector( 3 downto 0 );
	       D_OUT : out std_logic_vector( 6 downto 0 ) );
end SEG_DECODER;

architecture RTL of SEG_DECODER is 
begin
	process( D_IN ) begin
			case D_IN is			
		 	when "0000" => D_OUT <= "1000000"; -- 0
			when "0001" => D_OUT <= "1111001"; -- 1
			when "0010" => D_OUT <= "0100100"; -- 2
			when "0011" => D_OUT <= "0110000"; -- 3
	
			when "0100" => D_OUT <= "0011001"; -- 4
			when "0101" => D_OUT <= "0010010"; -- 5
			when "0110" => D_OUT <= "0000010"; -- 6
			when "0111" => D_OUT <= "1111000"; -- 7
	
			when "1000" => D_OUT <= "0000000"; -- 8
			when "1001" => D_OUT <= "0010000"; -- 9
			when "1010" => D_OUT <= "0001000"; -- a
			when "1011" => D_OUT <= "0000011"; -- b
	
			when "1100" => D_OUT <= "1000110"; -- c
			when "1101" => D_OUT <= "0100001"; -- d
			when "1110" => D_OUT <= "0000110"; -- e
			when "1111" => D_OUT <= "0001110"; -- f
			when others => NULL;
			end case;
	end process;
end RTL;
