library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity SEG_MUX is
	port( DATA_A, DATA_B, DATA_C, DATA_D : in  std_logic_vector( 6 downto 0 );
			SEL                            : in  std_logic_vector( 1 downto 0 );
			DATA_OUT                       : out std_logic_vector( 6 downto 0 );
			SA                             : out std_logic_vector( 3 downto 0 ) );
end SEG_MUX;

architecture RTL of SEG_MUX is
begin
	DATA_OUT <= DATA_A when SEL = "00" else
					DATA_B when SEL = "01" else
					DATA_C when SEL = "10" else DATA_D;

	SA       <= "0ZZZ" when SEL = "00" else 
	            "Z0ZZ" when SEL = "01" else
					"ZZ0Z" when SEL = "10" else
					"ZZZ0" when SEL = "11" else "ZZZZ";
end RTL;
