library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity CNT60 is
    Port ( CLK           : in std_logic;
           RST           : in std_logic;
			  CE            : in std_logic;
			  RESET_SW      : in std_logic;
			  STATE         : in std_logic;

           SEC6          : out std_logic_vector(3 downto 0);
           SEC10         : out std_logic_vector(3 downto 0));
end CNT60;

architecture RTL of CNT60 is

signal SEC_CNT6  : std_logic_vector( 2 downto 0 );
signal SEC_CNT10 : std_logic_vector( 3 downto 0 );
signal CARRY     : std_logic;

begin

SEC6  <= '0' & SEC_CNT6;
SEC10 <= SEC_CNT10;

process( CLK, RST, RESET_SW, STATE ) begin
	if( RST = '1') then
		SEC_CNT10 <= (others=>'0');
		CARRY     <= '0';
	elsif( RESET_SW='1') then
		SEC_CNT10 <= (others=>'0');
		CARRY     <= '0';
	elsif( STATE = '0') then
		NULL;
	elsif( CLK'event and CLK = '1') then
		if( CE = '1') then
			if( SEC_CNT10 = "1000" ) then
				SEC_CNT10 <= SEC_CNT10 + '1';
				CARRY     <= '1';				
			elsif( SEC_CNT10 = "1001" ) then
				SEC_CNT10 <= (others=>'0');
				CARRY     <= '0';
			else
				SEC_CNT10 <= SEC_CNT10 + '1';
				CARRY     <= '0';
			end if;
		end if;
	end if;
end process;

process( CLK, RST, RESET_SW, STATE ) begin
	if( RST = '1') then
		SEC_CNT6 <= (others=>'0');
	elsif( RESET_SW='1') then
		SEC_CNT6 <= (others=>'0');
	elsif( STATE = '0') then
		NULL;
	elsif( CLK'event and CLK = '1') then
		if( CE = '1') then
			if( CARRY = '1') then
				if( SEC_CNT6 = "101" ) then
					SEC_CNT6 <= (others=>'0');
				else
					SEC_CNT6 <= SEC_CNT6 + '1';
				end if;
			end if;
		end if;
	end if;
end process;

end RTL;
