-- C:\WORK\HDL\SAMPLE\EDXSPL02\STATE_MACHINE_WAVE.VHW
-- VHDL Test Bench created by
-- HDL Bencher 4.1i
-- Tue Aug 20 16:07:07 2002
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT STATE_MACHINE
		PORT (
			CLK : in  std_logic;
			RST : in  std_logic;
			STOP_SW : in  std_logic;
			STATE_OUT : out  std_logic
		);
	END COMPONENT;

	SIGNAL CLK : std_logic;
	SIGNAL RST : std_logic;
	SIGNAL STOP_SW : std_logic;
	SIGNAL STATE_OUT : std_logic;

BEGIN
	UUT : STATE_MACHINE
	PORT MAP (
		CLK => CLK,
		RST => RST,
		STOP_SW => STOP_SW,
		STATE_OUT => STATE_OUT
	);

	PROCESS -- clock process
	BEGIN
		CLOCK_LOOP : LOOP
		CLK <= transport '0';
		WAIT FOR 1 ns;
		CLK <= transport '1';
		WAIT FOR 1 ns;
		WAIT FOR 51 ns;
		CLK <= transport '0';
		WAIT FOR 51 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_STATE_OUT(
			next_STATE_OUT : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (STATE_OUT /= next_STATE_OUT) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns STATE_OUT="));
				write(TX_LOC, STATE_OUT);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_STATE_OUT);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		RST <= transport '1';
		STOP_SW <= transport '0';
		-- --------------------
		WAIT FOR 104 ns; -- Time=104 ns
		RST <= transport '0';
		-- --------------------
		WAIT FOR 104 ns; -- Time=208 ns
		STOP_SW <= transport '1';
		-- --------------------
		WAIT FOR 416 ns; -- Time=624 ns
		STOP_SW <= transport '1';
		-- --------------------
		WAIT FOR 104 ns; -- Time=728 ns
		STOP_SW <= transport '0';
		-- --------------------
		WAIT FOR 312 ns; -- Time=1040 ns
		STOP_SW <= transport '1';
		-- --------------------
		WAIT FOR 208 ns; -- Time=1248 ns
		STOP_SW <= transport '0';
		-- --------------------
		WAIT FOR 624 ns; -- Time=1872 ns
		STOP_SW <= transport '1';
		-- --------------------
		WAIT FOR 936 ns; -- Time=2808 ns
		STOP_SW <= transport '0';
		-- --------------------
		WAIT FOR 936 ns; -- Time=3744 ns
		STOP_SW <= transport '1';
		-- --------------------
		WAIT FOR 520 ns; -- Time=4264 ns
		STOP_SW <= transport '0';
		-- --------------------
		WAIT FOR 10349 ns; -- Time=14613 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION STATE_MACHINE_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END STATE_MACHINE_cfg;
